/*
** FmtVvz v1.0
**
** Description goes here
**
** Copyright (c) 29.3.94 by Andreas Ley <ley@rz.uni-karlsruhe.de>
**
** Permission to use, copy, modify, and distribute this software for any
** purpose and without fee is hereby granted, provided that the above
** copyright notice appears in all copies. This software is provided "as is"
** and without any express or implied warranties.
**
** This program has been tested on a HP9000/720 with HP-UX A.08.07
** In this environment, neither lint -u nor gcc -Wall produce any messages.
** If you encounter any errors or need to make any changes to port it
** to another platform, please contact me.
**
** Version history
**
** Version 1.0 - 29.3.94
**	Initial version
*/

char header[]="FmtVvz v1.0\n(c) 1994 by Andreas Ley\n";

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/param.h>

#define	FALSE	0		/* This is the naked Truth */
#define	TRUE	1		/* and this is the Light */

#define	MAXENTRIES	15	/* Number of time schedules for one lecture */
char	v_num[BUFSIZ],v_title[BUFSIZ],v_dozent[BUFSIZ],v_place[MAXENTRIES][BUFSIZ],v_day[MAXENTRIES][BUFSIZ],v_time[MAXENTRIES][BUFSIZ],v_hours[BUFSIZ],v_turnus[MAXENTRIES][BUFSIZ];
char	v_header[BUFSIZ],v_comment[BUFSIZ];
int	cnt;


FILE	*hs,*vv,*v;


char *strip(char *line)
{
	char	*ptr;

	while (*line==' ')
		line++;
	ptr=strchr(line,'\0');
	while (ptr>line&&ptr[-1]==' ')
		ptr--;
	*ptr='\0';
	return(line);
}



void outnum()
{
	int	i;

	if (*v_num) {
		(void)fprintf(v,"%s\n",v_num);
		(void)fprintf(vv,"%s\t%s\t%s\t%s",v_num,v_title,v_dozent,v_hours);
		for (i=0;i<=cnt;i++) {
			if (*v_place[i]||*v_day[i]||*v_time[i]||*v_turnus[i]) {
				(void)fprintf(hs,"%s\n",v_place[i]);
				(void)fprintf(vv,"\t%s\t%s\t%s\t%s",v_place[i],v_day[i],v_time[i],v_turnus[i]);
			}
		}
		(void)fprintf(vv,"\n");
		*v_num='\0';
		cnt=0;
	}
	if (*v_comment!='\1') {
		(void)fprintf(v,"C%s\n",v_comment);
		*v_comment='\1';
	}
}



void fmtvvz(FILE *src)
{
	char	line[BUFSIZ],*ptr,*nptr,error[MAXPATHLEN+14];
	int	ncnt,v_cnt;
	size_t	len;

	v_cnt=0;
	*v_num='\0';
	*v_comment='\1';
	cnt=0;
	while (fgets(line,sizeof(line),src)) {
		ptr=strchr(line,'\0');
		if (*(ptr-1)=='\n')
			ptr--;
		if (*(ptr-1)=='\r')
			ptr--;
		while (ptr>line &&  *(ptr-1)==' ')
			ptr--;
		*ptr='\0';

		len=strlen(line);
		if (line[0]==' ') {
			if (line[2]==' ') {
				/* continuation line */
				if (line[3]==' ') {
					/* v_continuation line */
					line[53]='\0';
					ptr=strip(line+8);
					if (*ptr) {
						nptr=strchr(v_title,'\0');
						if (nptr[-1]=='-'&&strncmp(ptr,"und ",4)) {
							if ('a'<=*ptr&&*ptr<='z')
								nptr[-1]='\0';
						}
						else {
							nptr[0]=' ';
							nptr[1]='\0';
						}
						(void)strcat(v_title,ptr);
					}
					line[90]='\0';
					ptr=strip(line+54);
					if (*ptr) {
						nptr=strchr(v_dozent,'\0');
						if (nptr[-1]=='-')
							nptr[-1]='\0';
						else
							(void)strcat(v_dozent," ");
						(void)strcat(v_dozent,ptr);
					}
					line[101]='\0';
					ptr=strip(line+91);
					if (*ptr) {
						if (!strncmp(ptr,"Gruppe ",7))
							continue;
						for(ncnt=cnt;ncnt&&!*v_place[ncnt];ncnt--);
						nptr=strchr(v_place[ncnt],'\0');
						if (nptr[-1]=='-') {
							if ('a'<=*ptr&&*ptr<='z')
								nptr[-1]='\0';
							(void)strcat(v_place[ncnt],ptr);
						}
						else if (line[102]
							&&strncmp(v_place[ncnt],"Karlstr.",8)&&strcmp(v_place[ncnt],"Flachbau")
							&&strcmp(v_place[ncnt],"Inst.f.")&&strcmp(v_place[ncnt],"Inst. f.")
							&&strncmp(ptr,"Karlstr.",8)&&strncmp(ptr,"Geb.",4)) {
							cnt++;
							*v_day[cnt]='\0';
							*v_time[cnt]='\0';
							*v_turnus[cnt]='\0';
							(void)strcpy(v_place[cnt],ptr);
						}
						else {
							if (*v_place[ncnt])
								(void)strcat(v_place[ncnt]," ");
							(void)strcat(v_place[ncnt],ptr);
						}
					}
					line[107]='\0';
					ptr=strip(line+102);
					if (*ptr) {
						if (*v_day[cnt]) {
							cnt++;
							*v_place[cnt]='\0';
							*v_time[cnt]='\0';
							*v_turnus[cnt]='\0';
						}
						(void)strcpy(v_day[cnt],ptr);
					}
					line[121]='\0';
					ptr=strip(line+108);
					if (*ptr) {
						if (*v_time[cnt]) {
							cnt++;
							*v_place[cnt]='\0';
							*v_day[cnt]='\0';
							*v_turnus[cnt]='\0';
						}
						(void)strcpy(v_time[cnt],ptr);
					}
					ptr=strip(line+127);
					if (*ptr) {
						if (*v_turnus[cnt]) {
							cnt++;
							*v_place[cnt]='\0';
							*v_day[cnt]='\0';
							*v_time[cnt]='\0';
						}
						(void)strcpy(v_turnus[cnt],ptr);
						if (!strcmp(v_turnus[cnt],"14-t"))
							(void)strcat(v_turnus[cnt],"g");
						if (!strcmp(v_turnus[cnt],"Bloc"))
							(void)strcat(v_turnus[cnt],"k");
					}
				}
				else {
					/* comment continuation line */
				}
			}
			else if ('0'<=line[2]&&line[2]<='9'&&'0'<=line[3]&&line[3]<='9'
				&&'0'<=line[4]&&line[4]<='9'&&'0'<=line[5]&&line[5]<='9'
				&&'0'<=line[6]&&line[6]<='9') {
				outnum();
				/* Numerical entry */
				line[7]='\0';
				(void)strcpy(v_num,strip(line));
				line[53]='\0';
				(void)strcpy(v_title,strip(line+8));
				line[90]='\0';
				(void)strcpy(v_dozent,strip(line+54));
				line[121]='\0';
				if (!strncmp(line+91,"in der vorlesungsfreien Zeit",28)
					||!strncmp(line+91,"Ort u.Zeit",10)
					||!strncmp(line+91,"Termin ",7)) {
					*v_place[cnt]='\0';
					(void)strcpy(v_day[cnt],strip(line+91));
					*v_time[cnt]='\0';
				}
				else {
					line[101]='\0';
					(void)strcpy(v_place[cnt],strip(line+91));
					line[121]='\0';
					if (strncmp(line+102,"Mo",2)&&strncmp(line+102,"Di",2)&&strncmp(line+102,"Mi",2)&&strncmp(line+102,"Do",2)&&strncmp(line+102,"Fr",2)&&strncmp(line+102,"Sa",2)&&strncmp(line+102,"So",2)&&line[102]&&line[102]!=' ') {
						(void)strcpy(v_day[cnt],strip(line+102));
						*v_time[cnt]='\0';
					}
					else {
						line[107]='\0';
						(void)strcpy(v_day[cnt],strip(line+102));
						(void)strcpy(v_time[cnt],strip(line+108));
					}
				}
				line[126]='\0';
				(void)strcpy(v_hours,strip(line+122));
				(void)strcpy(v_turnus[cnt],strip(line+127));
				if (!strcmp(v_turnus[cnt],"14-t"))
					(void)strcat(v_turnus[cnt],"g");
				if (!strcmp(v_turnus[cnt],"Bloc"))
					(void)strcat(v_turnus[cnt],"k");
			}
			else {
				outnum();
				if (strncmp(line,"  Lv-Nr",7)) {
					/* Shortcut */
					(void)strcpy(v_comment,strip(line));
				}
			}
		}
		else if (*line=='*') {
			outnum();
			/* comment line */
			(void)strcpy(v_comment,strip(line));
		}
		else if (!strncmp(line,"(F1)",4)) {
			outnum();
			/* Header line */
			line[68]='\0';
			if (strcmp(v_header,strip(line+16))) {
				(void)strcpy(v_header,strip(line+16));
				(void)fclose(v);
				(void)sprintf(line,"%02d",v_cnt++);
				v=fopen(line,"w");
				if (!v) {
					(void)sprintf(error,"Cannot open '%s'",line);
					perror(error);
					exit(1);
				}
				(void)fprintf(v,"H%s\n",v_header);
			}
		}
		else if (*line=='-'||*line=='=') {
			if (*v_comment!='\1')
				(void)fprintf(v,"H%s\n",v_comment);
			*v_comment='\1';
		}
		else {
			outnum();
			/* Anything */
			(void)strcpy(v_comment,strip(line));
		}
		(void)memset((void *)line,0,len);
	}
	outnum();
}



void usage(image)
char *image;
{
	(void)fprintf(stderr,"Usage: %s [-h] [-v] [filename...]\n",image);
	exit(1);
}


int main(argc,argv)
int	argc;
char	*argv[];
{
	int		c;
	extern int	optind;
	char		error[MAXPATHLEN+14];
	FILE		*src;

	while ((c=getopt(argc,argv,"vh?")) != EOF)
		switch ((char)c) {
		case 'v':
			(void)fprintf(stderr,header);
			exit(0);
		case 'h':
			(void)fprintf(stderr,header);
		case '?':
			usage(argv[0]);
		}

	hs=fopen("places","w");
	if (!hs) {
		perror("Cannot open 'places'");
		exit(1);
	}

	vv=fopen("lectures","w");
	if (!hs) {
		perror("Cannot open 'lectures'");
		exit(1);
	}

	if (optind<argc)
		for (;optind<argc;optind++)
			if (strcmp(argv[optind],"-"))
				if ((src=fopen(argv[optind],"r"))) {
					fmtvvz(src);
					(void)fclose(src);
				}
				else {
					(void)sprintf(error,"Cannot open '%s'",argv[optind]);
					perror(error);
				}
			else
				fmtvvz(stdin);
	else
		fmtvvz(stdin);

	(void)fclose(v);
	(void)fclose(vv);
	(void)fclose(hs);
	return(0);
}
